var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import * as R from 'ramda';
import Ajv from 'ajv';
import * as fs from 'fs-extra';
import * as path from 'path';
const del = function (dist, src, filepath) {
    return __awaiter(this, void 0, void 0, function* () {
        const distfilepath = path.join(dist, filepath);
        yield fs.remove(distfilepath);
        return '/dev/null';
    });
};
const ajv = new Ajv();
export const compile = function (dist, src, filepath, resource, options) {
    return __awaiter(this, void 0, void 0, function* () {
        if (('schema' in options)) {
            const validate = ajv.compile(options.schema);
            const valid = validate(R.fromPairs(Array.from(resource.entries())));
            if (valid)
                return del(dist, src, filepath, resource, options);
        }
        else {
            return del(dist, src, filepath, resource, options);
        }
    });
};
