var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import AJV from 'ajv';
import ajvKeywords from 'ajv-keywords';
import * as handlerSchema from "./schema/handler.json";
const ajv = new AJV();
ajvKeywords(ajv);
const validate = ajv.compile(handlerSchema);
export function execHandler(dist, src, filepath, resource, handler) {
    return __awaiter(this, void 0, void 0, function* () {
        const pkg = yield import(handler.name);
        const valid = validate(pkg);
        if (!valid)
            throw new Error(ajv.errorsText(validate.errors, { dataVar: 'loader' }));
        // TODO: Check Hanlder engines
        return yield pkg.compile(dist, src, filepath, resource, handler.options);
    });
}
