export declare const TemplateSchema: {
    $id: string;
    type: string;
    properties: {
        path: {
            type: string;
            default: string;
        };
        engines: {
            type: string;
        };
        rules: {
            type: string;
            items: {
                $ref: string;
            };
            default: never[];
        };
        hooks: {
            type: string;
            propertyNames: {
                enum: string[];
            };
            patternProperties: {
                ".*": {
                    oneOf: ({
                        type: string;
                        instanceof?: undefined;
                    } | {
                        instanceof: string;
                        type?: undefined;
                    })[];
                };
            };
        };
        questions: {
            type: string;
            items: {
                $ref: string;
            };
        };
    };
};
export declare const RuleSchema: {
    $id: string;
    type: string;
    properties: {
        path: {
            type: string;
        };
        encoding: {
            oneOf: ({
                type: string;
                enum: string[];
                propertyNames?: undefined;
                patternProperties?: undefined;
            } | {
                type: string;
                propertyNames: {
                    enum: string[];
                };
                patternProperties: {
                    ".*": {
                        type: string;
                    };
                };
                enum?: undefined;
            })[];
        };
        upgrade: {
            type: string;
            enum: string[];
            default: string;
        };
        glob: {
            type: string;
            default: boolean;
        };
        handler: {
            $ref: string;
        };
        handlers: {
            type: string;
            items: {
                $ref: string;
            };
        };
    };
    required: string[];
};
export declare const HandlerSchema: {
    $id: string;
    anyOf: ({
        type: string;
        instanceof?: undefined;
        properties?: undefined;
    } | {
        instanceof: string;
        type?: undefined;
        properties?: undefined;
    } | {
        type: string;
        properties: {
            genFile: {
                instanceof: string;
            };
            genPath: {
                instanceof: string;
            };
        };
        instanceof?: undefined;
    })[];
};
export declare const QuestionSchema: {
    $id: string;
    type: string;
    properties: {
        type: {
            type: string;
            enum: string[];
        };
        name: {
            type: string;
        };
    };
    required: string[];
};
export declare const MilircSchema: {
    $id: string;
    type: string;
    properties: {
        template: {
            type: string;
        };
        version: {
            type: string;
        };
        answers: {
            type: string;
            nullable: boolean;
            properties: {};
        };
    };
    required: string[];
};
