var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import * as fs from 'fs-extra';
import simpleGit from 'simple-git';
import * as ora from 'ora';
import * as path from 'path';
export function copy(src, dist, showProgress = false) {
    return __awaiter(this, void 0, void 0, function* () {
        const git = simpleGit(src);
        const spinner = ora({
            text: 'Load Files',
            discardStdin: true,
        });
        if (showProgress)
            spinner.start();
        yield fs.copy(src, dist, {
            filter: (srcFile) => __awaiter(this, void 0, void 0, function* () {
                const relativePath = path.relative(src, srcFile);
                if (showProgress)
                    spinner.text = `Load Files: ${relativePath}`;
                const result = yield git.checkIgnore(srcFile);
                return !result.length;
            }),
        });
        if (showProgress)
            spinner.succeed('Load All Files');
    });
}
