var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { TEMPORARY_FILEPATH } from "../const";
import * as fs from 'fs-extra';
import * as path from 'path';
import { v4 as uuid } from 'uuid';
export function createTmpDir() {
    return __awaiter(this, void 0, void 0, function* () {
        const tmpPath = path.join(TEMPORARY_FILEPATH, uuid());
        if (yield fs.pathExists(tmpPath))
            throw new Error('Folder is used by another process.');
        yield fs.ensureDir(tmpPath);
        return tmpPath;
    });
}
