"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.check = void 0;
const fs = require("fs-extra");
const render_1 = require("./render");
const create_tmp_dir_1 = require("./util/create-tmp-dir");
const parse_template_1 = require("./util/parse-template");
const diff_1 = require("./diff");
const copy_1 = require("./util/copy");
function check(options) {
    return __awaiter(this, void 0, void 0, function* () {
        const { template, version = 'latest', cwd = process.cwd(), showDiff = false, fold = false, answers = {}, } = options;
        const tmpDir = yield create_tmp_dir_1.createTmpDir();
        yield copy_1.copy(cwd, tmpDir);
        const repository = parse_template_1.parseTemplate(template, version);
        yield render_1.render(tmpDir, repository, answers);
        yield diff_1.diff(cwd, tmpDir, { fold, showDiff });
        yield fs.remove(tmpDir);
    });
}
exports.check = check;
