"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.compile = void 0;
const fs = require("fs-extra");
const R = require("ramda");
const path = require("path");
const compile = function (dist, src, filepath, resource, options) {
    return __awaiter(this, void 0, void 0, function* () {
        const encoding = options.encoding;
        const distfilepath = path.join(dist, filepath);
        const srcfilepath = path.join(src, filepath);
        const jsonInProject = (yield fs.pathExists(distfilepath)) ? yield fs.readJSON(distfilepath, { encoding }) : null;
        const jsonInTemplate = yield fs.readJSON(srcfilepath, { encoding });
        const json = R.mergeDeepRight(jsonInProject, jsonInTemplate);
        yield fs.writeJSON(srcfilepath, json);
    });
};
exports.compile = compile;
