"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.init = void 0;
const render_1 = require("./render");
const check_1 = require("./util/check");
const parse_template_1 = require("./util/parse-template");
function init(options) {
    return __awaiter(this, void 0, void 0, function* () {
        const { template, version = 'latest', cwd = process.cwd(), force = false, } = options;
        if (!force)
            yield check_1.check(cwd);
        const tmpDir = cwd;
        const repository = parse_template_1.parseTemplate(template, version);
        yield render_1.render(tmpDir, repository, {});
    });
}
exports.init = init;
