"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.exec = void 0;
const fs = require("fs-extra");
const path = require("path");
const exec = function (cwd, options) {
    return __awaiter(this, void 0, void 0, function* () {
        const packageJsonFilepath = path.join(cwd, 'package.json');
        if (!(yield fs.pathExists(packageJsonFilepath))) {
            return {
                npm: {
                    name: options.name || path.basename(path.dirname(cwd)),
                    version: options.version || '0.0.1',
                    description: options.description || '',
                },
            };
        }
        const config = yield fs.readJSON(packageJsonFilepath);
        return {
            npm: {
                name: config.name,
                version: config.version,
                description: config.description,
            },
        };
    });
};
exports.exec = exec;
