"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.migrate = void 0;
const semver = require("semver");
const fs = require("fs-extra");
const path = require("path");
const child_process_1 = require("child_process");
function migrate(cwd, repository, fromVersion) {
    if (fromVersion === repository.version)
        return;
    if (!semver.valid(fromVersion))
        throw new Error(`Invalid version ${fromVersion}`);
    if (!fs.pathExists(path.join(repository.storage, 'migration')))
        return;
    const files = fs.readdirSync(path.join(repository.storage, 'migration'));
    for (const file of files) {
        child_process_1.execFileSync(file, [], { cwd });
    }
}
exports.migrate = migrate;
