"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.execHandler = void 0;
const ajv_1 = require("ajv");
const ajv_keywords_1 = require("ajv-keywords");
const handlerSchema = require("./schema/handler.json");
const ajv = new ajv_1.default();
ajv_keywords_1.default(ajv);
const validate = ajv.compile(handlerSchema);
function execHandler(dist, src, filepath, resource, handler) {
    return __awaiter(this, void 0, void 0, function* () {
        const pkg = yield Promise.resolve().then(() => require(handler.name));
        const valid = validate(pkg);
        if (!valid)
            throw new Error(ajv.errorsText(validate.errors, { dataVar: 'loader' }));
        // TODO: Check Hanlder engines
        return yield pkg.compile(dist, src, filepath, resource, handler.options);
    });
}
exports.execHandler = execHandler;
